<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelCupomPromoService {

    public function __construct(EntityManager $entityManager) {
      $this->entityManager = $entityManager;
  }
  
  public function find($conditions) {

    $params = array(
        ":TCDFILIAL" => 'F',
        ":CDFILIAL" => $conditions['CDFILIAL'],
        ":DATAINI" => $conditions['DATAINI'],
        ":DATAFIN" => $conditions['DATAFIN'],
        ":CDLOJA" => $conditions['CDLOJA'],
        ":TCDLOJA" => $conditions['TCDLOJA'],
        ":CDCUPOMDESCFOS" => $conditions['CDCUPOMDESCFOS'],
        ":TCDCUPOMDESCFOS" => $conditions['TCDCUPOMDESCFOS'],
        ":CDPRODLIST" => $conditions['CDPRODLIST'],
        ":CDPRODINI" => $conditions['CDARVPRODI'],
        ":CDPRODFIN" => $conditions['CDARVPRODF'],
        ":PRODNIV" => $conditions['PRODNIV'],
        ":TCDPRODUTO" => $conditions['TCDPRODUTO'],
        ":NRORG" => $conditions['NRORG']
    );
    
    return $this->entityManager->getConnection()->fetchAll(self::GET_SALES_CUPOM_DESCONTO, $params);
  }
  
  const GET_SALES_CUPOM_DESCONTO = "
    SELECT U.CDCUPOMDESCFOS AS CDCUPOMDESCFOS2, U.CDCUPOMDESCFOS, C.DSCUPOMDESCFOS, C.DTINIVIGENCIA, C.DTFIMVIGENCIA, U.CDFILIAL, U.CDFILIAL||' - '||V.NMFILIAL AS LABELFILIAL, COUNT(*) AS TOT
      FROM USOCUPOMDESCFOS U 
      JOIN CUPOMDESCFOS C
        ON U.CDCUPOMDESCFOS = C.CDCUPOMDESCFOS
      JOIN (SELECT DISTINCT VE.CDFILIAL, VE.CDCAIXA, VE.CDLOJA, VE.NRSEQVENDA, VE.DTENTRVENDA, FILTROGER.NMFILIAL
              FROM VENDA VE
              JOIN (SELECT DISTINCT C.CDFILIAL, C.CDCAIXA, L.CDLOJA, C.NMFILIAL
                      FROM LOJA L,
                           (SELECT DISTINCT F.CDFILIAL, CX.CDCAIXA, CX.CDLOJA, F.NMFILIAL
                              FROM CAIXA CX,
                                   (SELECT DISTINCT CDFILIAL, NMFILIAL
                                      FROM FILIAL
                                     WHERE ((INSTR(:CDFILIAL, CDFILIAL) <> 0) OR (:TCDFILIAL = 'T'))
                                   ) F
                             WHERE CX.CDFILIAL = F.CDFILIAL
                           ) C
                     WHERE L.CDFILIAL = C.CDFILIAL
                       AND L.CDLOJA     = C.CDLOJA
                       AND ((INSTR(:CDLOJA, L.CDFILIAL || L.CDLOJA) <> 0) OR (:TCDLOJA   = 'T')) 
                   ) FILTROGER
                ON VE.CDFILIAL      = FILTROGER.CDFILIAL
               AND VE.CDLOJA        = FILTROGER.CDLOJA
               AND VE.CDCAIXA       = FILTROGER.CDCAIXA
             WHERE VE.IDSITUVENDA = 'O'
               AND VE.DTENTRVENDA BETWEEN :DATAINI AND :DATAFIN ) V
        ON U.CDFILIAL = V.CDFILIAL
       AND U.CDCAIXA = V.CDCAIXA
       AND U.NRSEQVENDA = V.NRSEQVENDA
      JOIN ITEMVENDA I
        ON U.CDFILIAL = I.CDFILIAL
       AND U.CDCAIXA = I.CDCAIXA
       AND U.NRSEQVENDA = I.NRSEQVENDA
       AND U.NRSEQUITVEND = I.NRSEQUITVEND
      JOIN PRODUTO P
        ON I.CDPRODUTO = P.CDPRODUTO
       AND I.NRORG = P.NRORG
     WHERE ((INSTR( :CDCUPOMDESCFOS, U.CDCUPOMDESCFOS ) > 0 ) OR ( :TCDCUPOMDESCFOS = 'T'))
       AND ( ( ( ( ( INSTR(:CDPRODLIST, I.CDPRODUTO) > 0 ) OR ( P.CDARVPROD BETWEEN :CDPRODINI AND :CDPRODFIN ) ) ) OR ( P.CDARVPROD LIKE :PRODNIV ) ) OR ( :TCDPRODUTO = 'T' ) )
     GROUP BY U.CDCUPOMDESCFOS, C.DSCUPOMDESCFOS, C.DTINIVIGENCIA, C.DTFIMVIGENCIA, U.CDFILIAL, V.NMFILIAL
  ";
}